$(() => {
const tabPanel = $('#tabPanel').dxTabPanel({
dataSource: employees.slice(0, 3),
itemTitleTemplate: titleTemplate,
itemTemplate,
height: 410,
deferRendering: false,
showNavButtons: true,
repaintChangesOnly: true,
}).dxTabPanel('instance');
$('#tabPanel').dxSortable({
moveItemOnDrop: true,
filter: '.dx-tab',
itemOrientation: 'horizontal',
dragDirection: 'horizontal',
onReorder(e) {
const tabPanelItems = tabPanel.option('dataSource');
const itemData = tabPanelItems.splice(e.fromIndex, 1)[0];
tabPanelItems.splice(e.toIndex, 0, itemData);
tabPanel.option('dataSource', tabPanelItems);
tabPanel.option('selectedIndex', e.toIndex);
},
});
const addTabButton = $('#addButton').dxButton({
icon: 'add',
text: 'Add Tab',
type: 'default',
onClick: addButtonHandler,
}).dxButton('instance');
function titleTemplate(itemData, itemIndex, itemElement) {
itemElement
.append($('<span>').text(`${itemData.FirstName} ${itemData.LastName}`));
if (!itemData.isLast) {
itemElement
.append(
$('<i>')
.addClass('dx-icon')
.addClass('dx-icon-close')
.click(() => { closeButtonHandler(itemData); }),
);
}
}
function itemTemplate(itemData, itemIndex, itemElement) {
$('<div>')
.addClass('employeeInfo')
.append($(`<img class="employeePhoto" src="${itemData.Picture}"/>`))
.append($('<p>').addClass('employeeNotes').append($(`<b>Position: ${itemData.Position}</b><br/>`)).append(itemData.Notes))
.appendTo(itemElement);
$('<div>')
.addClass('caption')
.text(`${itemData.FirstName} ${itemData.LastName}'s Tasks:`)
.appendTo(itemElement);
const employeeTasks = tasks.filter((task) => task.EmployeeID === itemData.ID);
$('<div>')
.addClass('task-list')
.appendTo(itemElement)
.dxList({
dataSource: employeeTasks,
selectionMode: 'multiple',
showSelectionControls: true,
disabled: true,
selectedItems: employeeTasks.filter((task) => task.Status === 'Completed'),
itemTemplate(data) {
return $(`<div>${data.Subject}</div>`);
},
});
}
function addButtonHandler() {
const tabPanelItems = tabPanel.option('dataSource');
const newItem = employees.filter((employee) => tabPanelItems.indexOf(employee) === -1)[0];
tabPanelItems.push(newItem);
updateButtonsState(tabPanelItems);
tabPanel.option('dataSource', tabPanelItems);
tabPanel.option('selectedIndex', tabPanelItems.length - 1);
}
function closeButtonHandler(itemData) {
const index = tabPanel.option('dataSource').indexOf(itemData);
const tabPanelItems = tabPanel.option('dataSource');
tabPanelItems.splice(index, 1);
updateButtonsState(tabPanelItems);
tabPanel.option('dataSource', tabPanelItems);
if (index >= tabPanelItems.length && index > 0) tabPanel.option('selectedIndex', index - 1);
}
function updateButtonsState(items) {
addTabButton.option('disabled', items.length === employees.length);
items[0].isLast = items.length === 1;
}
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/21.2.7/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/21.2.7/css/dx.light.css" />
<script src="https://cdn3.devexpress.com/jslib/21.2.7/js/dx.all.js"></script>
<script src="js/underscore.js"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="container">
<div id="addButton"></div>
</div>
<div id="tabPanel"></div>
</div>
</body>
</html>
#container {
display: flex;
justify-content: flex-end;
padding-bottom: 10px;
}
.dx-tabs .dx-tabs-wrapper .dx-tab {
width: auto;
padding-left: 20px;
}
.dx-tab-content .dx-icon-close {
display: inline-block;
opacity: 0.6;
margin-right: 0;
margin-left: 7px;
font-size: 18px;
}
.dx-sortable-dragging .dx-tab {
box-sizing: border-box;
text-align: center;
}
.employeeInfo .employeePhoto {
height: 100px;
float: left;
padding: 10px 20px 10px 20px;
}
.caption {
padding: 0 0 10px 30px;
font-size: 14px;
font-weight: bold;
}
.task-list {
padding: 0 20px;
}
.task-list.dx-state-disabled {
opacity: 1;
}
.task-list.dx-state-disabled .dx-list-item {
opacity: 1;
}
.employeeInfo .employeeNotes {
min-height: 100px;
padding: 20px;
text-align: justify;
white-space: normal;
}
.dx-theme-generic .dx-tabs-wrapper .dx-tab {
padding-left: 14px;
padding-right: 9px;
line-height: 1.618;
}
.dx-theme-generic .dx-icon-close {
font-size: 15px;
}
.dx-theme-material .dx-tab-content span {
vertical-align: middle;
line-height: initial;
}
.dx-theme-material .employeeNotes {
margin: 0;
}
const employees = [{
ID: 1,
FirstName: 'John',
LastName: 'Heart',
Prefix: 'Mr.',
Position: 'CEO',
Picture: '../../../../images/employees/01.png',
BirthDate: '1964/03/16',
HireDate: '1995/01/15',
Notes: 'John has been in the Audio/Video industry since 1990. He has led DevAv as its CEO since 2003. When not working hard as the CEO, John loves to golf and bowl. He once bowled a perfect game of 300.',
Address: '351 S Hill St.',
State: 'California',
City: 'Los Angeles',
}, {
ID: 2,
FirstName: 'Olivia',
LastName: 'Peyton',
Prefix: 'Mrs.',
Position: 'Sales Assistant',
Picture: '../../../../images/employees/09.png',
BirthDate: '1981/06/03',
HireDate: '2012/05/14',
Notes: 'Olivia loves to sell. She has been selling DevAV products since 2012. Olivia was homecoming queen in high school. She is expecting her first child in 6 months. Good Luck Olivia.',
Address: '807 W Paseo Del Mar',
State: 'California',
City: 'Los Angeles',
}, {
ID: 3,
FirstName: 'Robert',
LastName: 'Reagan',
Prefix: 'Mr.',
Position: 'CMO',
Picture: '../../../../images/employees/03.png',
BirthDate: '1974/09/07',
HireDate: '2002/11/08',
Notes: 'Robert was recently voted the CMO of the year by CMO Magazine. He is a proud member of the DevAV Management Team. Robert is a championship BBQ chef, so when you get the chance ask him for his secret recipe.',
Address: '4 Westmoreland Pl.',
State: 'Arkansas',
City: 'Bentonville',
}, {
ID: 4,
FirstName: 'Greta',
LastName: 'Sims',
Prefix: 'Ms.',
Position: 'HR Manager',
Picture: '../../../../images/employees/04.png',
BirthDate: '1977/11/22',
HireDate: '1998/04/23',
Notes: "Greta has been DevAV's HR Manager since 2003. She joined DevAV from Sonee Corp. Greta is currently training for the NYC marathon. Her best marathon time is 4 hours. Go Greta.",
Address: '1700 S Grandview Dr.',
State: 'Georgia',
City: 'Atlanta',
}, {
ID: 5,
FirstName: 'Brett',
LastName: 'Wade',
Prefix: 'Mr.',
Position: 'IT Manager',
Picture: '../../../../images/employees/05.png',
BirthDate: '1968/12/01',
HireDate: '2009/03/06',
Notes: 'Brett came to DevAv from Microsoft and has led our IT department since 2012. When he is not working hard for DevAV, he coaches Little League (he was a high school pitcher).',
Address: '1120 Old Mill Rd.',
State: 'Idaho',
City: 'Boise',
}, {
ID: 6,
FirstName: 'Sandra',
LastName: 'Johnson',
Prefix: 'Mrs.',
Position: 'Controller',
Picture: '../../../../images/employees/06.png',
BirthDate: '1974/11/15',
HireDate: '2005/05/11',
Notes: "Sandra is a CPA and has been our controller since 2008. She loves to interact with staff so if you've not met her, be certain to say hi. Sandra has 2 daughters both of whom are accomplished gymnasts.",
Address: '4600 N Virginia Rd.',
State: 'Utah',
City: 'Beaver',
}, {
ID: 7,
FirstName: 'Kevin',
LastName: 'Carter',
Prefix: 'Mr.',
Position: 'Shipping Manager',
Picture: '../../../../images/employees/07.png',
BirthDate: '1978/01/09',
HireDate: '2009/08/11',
Notes: 'Kevin is our hard-working shipping manager and has been helping that department work like clockwork for 18 months. When not in the office, he is usually on the basketball court playing pick-up games.',
Address: '424 N Main St.',
State: 'California',
City: 'San Diego',
}, {
ID: 8,
FirstName: 'Cynthia',
LastName: 'Stanwick',
Prefix: 'Ms.',
Position: 'HR Assistant',
Picture: '../../../../images/employees/08.png',
BirthDate: '1985/06/05',
HireDate: '2008/03/24',
Notes: 'Cindy joined us in 2008 and has been in the HR department for 2 years. She was recently awarded employee of the month. Way to go Cindy!',
Address: '2211 Bonita Dr.',
State: 'Arkansas',
City: 'Little Rock',
}, {
ID: 9,
FirstName: 'Kent',
LastName: 'Samuelson',
Prefix: 'Dr.',
Position: 'Ombudsman',
Picture: '../../../../images/employees/02.png',
BirthDate: '1972/09/11',
HireDate: '2009/04/22',
Notes: 'As our ombudsman, Kent is on the front-lines solving customer problems and helping our partners address issues out in the field. He is a classically trained musician and is a member of the Chamber Orchestra.',
Address: '12100 Mora Dr',
State: 'Missouri',
City: 'St. Louis',
}];
const tasks = [{
ID: 1,
Subject: 'Prepare 2013 Financial',
StartDate: '2013/01/15',
DueDate: '2013/01/31',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 8,
},
{
ID: 2,
Subject: 'Prepare 3013 Marketing Plan',
StartDate: '2013/01/01',
DueDate: '2013/01/31',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 5,
},
{
ID: 3,
Subject: 'Update Personnel Files',
StartDate: '2013/02/03',
DueDate: '2013/02/28',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 2,
},
{
ID: 4,
Subject: 'Review Health Insurance Options Under the Affordable Care Act',
StartDate: '2013/02/12',
DueDate: '2013/04/25',
Status: 'In Progress',
Priority: 'High',
Completion: 50,
EmployeeID: 2,
},
{
ID: 5,
Subject: 'Choose between PPO and HMO Health Plan',
StartDate: '2013/02/15',
DueDate: '2013/04/15',
Status: 'In Progress',
Priority: 'High',
Completion: 75,
EmployeeID: 1,
},
{
ID: 6,
Subject: 'Google AdWords Strategy',
StartDate: '2013/02/16',
DueDate: '2013/02/28',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 1,
},
{
ID: 7,
Subject: 'New Brochures',
StartDate: '2013/02/17',
DueDate: '2013/02/24',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 1,
},
{
ID: 11,
Subject: 'Rollout of New Website and Marketing Brochures',
StartDate: '2013/02/20',
DueDate: '2013/02/28',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 5,
},
{
ID: 12,
Subject: 'Update Sales Strategy Documents',
StartDate: '2013/02/20',
DueDate: '2013/02/22',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 9,
},
{
ID: 15,
Subject: 'Review 2012 Sales Report and Approve 2013 Plans',
StartDate: '2013/02/23',
DueDate: '2013/02/28',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 5,
},
{
ID: 16,
Subject: 'Deliver R&D Plans for 2013',
StartDate: '2013/03/01',
DueDate: '2013/03/10',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 3,
},
{
ID: 20,
Subject: 'Approve Hiring of John Jeffers',
StartDate: '2013/03/02',
DueDate: '2013/03/12',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 4,
},
{
ID: 20,
Subject: 'Approve Hiring of John Jeffers',
StartDate: '2013/03/02',
DueDate: '2013/03/12',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 6,
},
{
ID: 21,
Subject: 'Non-Compete Agreements',
StartDate: '2013/03/12',
DueDate: '2013/03/14',
Status: 'Completed',
Priority: 'Low',
Completion: 100,
EmployeeID: 2,
},
{
ID: 22,
Subject: 'Update NDA Agreement',
StartDate: '2013/03/14',
DueDate: '2013/03/16',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 1,
},
{
ID: 23,
Subject: 'Update Employee Files with New NDA',
StartDate: '2013/03/16',
DueDate: '2013/03/26',
Status: 'Need Assistance',
Priority: 'Normal',
Completion: 90,
EmployeeID: 4,
},
{
ID: 24,
Subject: 'Update Employee Files with New NDA',
StartDate: '2013/03/16',
DueDate: '2013/03/26',
Status: 'Need Assistance',
Priority: 'Normal',
Completion: 90,
EmployeeID: 6,
},
{
ID: 25,
Subject: 'Sign Updated NDA',
StartDate: '2013/03/20',
DueDate: '2013/03/25',
Status: 'Completed',
Priority: 'Urgent',
Completion: 100,
EmployeeID: 7,
},
{
ID: 26,
Subject: 'Sign Updated NDA',
StartDate: '2013/03/20',
DueDate: '2013/03/25',
Status: 'Completed',
Priority: 'Urgent',
Completion: 100,
EmployeeID: 8,
},
{
ID: 27,
Subject: 'Sign Updated NDA',
StartDate: '2013/03/20',
DueDate: '2013/03/25',
Status: 'Need Assistance',
Priority: 'Urgent',
Completion: 25,
EmployeeID: 9,
},
{
ID: 35,
Subject: 'Update Revenue Projections',
StartDate: '2013/03/24',
DueDate: '2013/04/07',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 8,
},
{
ID: 36,
Subject: 'Review Revenue Projections',
StartDate: '2013/03/25',
DueDate: '2013/04/06',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 9,
},
{
ID: 40,
Subject: 'Provide New Health Insurance Docs',
StartDate: '2013/03/28',
DueDate: '2013/04/07',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 4,
},
{
ID: 41,
Subject: 'Provide New Health Insurance Docs',
StartDate: '2013/03/28',
DueDate: '2013/04/07',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 6,
},
{
ID: 50,
Subject: 'Give Final Approval for Refunds',
StartDate: '2013/05/05',
DueDate: '2013/05/15',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 2,
},
{
ID: 52,
Subject: 'Review Product Recall Report by Engineering Team',
StartDate: '2013/05/17',
DueDate: '2013/05/20',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 1,
},
{
ID: 55,
Subject: 'Review Overtime Report',
StartDate: '2013/06/10',
DueDate: '2013/06/14',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 7,
},
{
ID: 60,
Subject: 'Refund Request Template',
StartDate: '2013/06/17',
DueDate: '2014/04/01',
Status: 'Deferred',
Priority: 'Normal',
Completion: 0,
EmployeeID: 9,
},
{
ID: 71,
Subject: 'Upgrade Server Hardware',
StartDate: '2013/07/22',
DueDate: '2013/07/31',
Status: 'Completed',
Priority: 'Urgent',
Completion: 100,
EmployeeID: 7,
},
{
ID: 72,
Subject: 'Upgrade Personal Computers',
StartDate: '2013/07/24',
DueDate: '2014/04/30',
Status: 'In Progress',
Priority: 'Normal',
Completion: 85,
EmployeeID: 7,
},
{
ID: 74,
Subject: 'Decide on Mobile Devices to Use in the Field',
StartDate: '2013/07/30',
DueDate: '2013/08/02',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 3,
},
{
ID: 78,
Subject: 'Try New Touch-Enabled WinForms Apps',
StartDate: '2013/08/11',
DueDate: '2013/08/15',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 3,
},
{
ID: 81,
Subject: 'Review Site Up-Time Report',
StartDate: '2013/08/24',
DueDate: '2013/08/30',
Status: 'Completed',
Priority: 'Urgent',
Completion: 100,
EmployeeID: 5,
},
{
ID: 99,
Subject: 'Submit D&B Number to ISP for Credit Approval',
StartDate: '2013/11/04',
DueDate: '2013/11/07',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 8,
},
{
ID: 117,
Subject: 'Approval on Converting to New HDMI Specification',
StartDate: '2014/01/11',
DueDate: '2014/01/31',
Status: 'Deferred',
Priority: 'Normal',
Completion: 75,
EmployeeID: 3,
},
{
ID: 138,
Subject: 'Review HR Budget Company Wide',
StartDate: '2014/03/20',
DueDate: '2014/03/25',
Status: 'In Progress',
Priority: 'Normal',
Completion: 40,
EmployeeID: 6,
},
{
ID: 145,
Subject: 'Final Budget Review',
StartDate: '2014/03/26',
DueDate: '2014/03/27',
Status: 'In Progress',
Priority: 'High',
Completion: 25,
EmployeeID: 6,
}];

<div id="container">
<dx-button
[disabled]="disableButton()"
text="Add Tab"
icon="add"
type="default"
(onClick)="addButtonHandler()"
></dx-button>
</div>
<dx-sortable
filter=".dx-tab"
[data]="employees"
itemOrientation="horizontal"
dragDirection="horizontal"
(onDragStart)="onTabDragStart($event)"
(onReorder)="onTabDrop($event)"
>
<dx-tab-panel
[dataSource]="employees"
[height]="410"
itemTitleTemplate="title"
itemTemplate="item"
[deferRendering]="false"
[showNavButtons]="true"
[repaintChangesOnly]="true"
[selectedIndex]="selectedIndex"
>
<div *dxTemplate="let content of 'title'">
<span>{{ content.FirstName }} {{ content.LastName }}</span
><i
*ngIf="showCloseButton()"
class="dx-icon dx-icon-close"
(click)="closeButtonHandler(content)"
></i>
</div>
<div *dxTemplate="let employee of 'item'">
<div class="employeeInfo">
<img class="employeePhoto" [src]="employee.Picture" />
<p class="employeeNotes"
><b>Position: {{ employee.Position }}</b
><br />{{ employee.Notes }}</p
>
</div>
<div class="caption">{{
employee.FirstName + " " + employee.LastName + "'s Tasks:"
}}</div>
<div class="task-list">
<dx-list
[dataSource]="getTasks(employee.ID)"
[showSelectionControls]="true"
[selectedItems]="getCompletedTasks(employee.ID)"
[disabled]="true"
selectionMode="multiple"
>
<div *dxTemplate="let item of 'item'">
<div>{{ item.Subject }}</div>
</div>
</dx-list>
</div>
</div>
</dx-tab-panel>
</dx-sortable>
import { NgModule, Component, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import {
DxButtonModule, DxSortableModule, DxTabPanelModule, DxListModule, DxTemplateModule,
} from 'devextreme-angular';
import { Employee, Service, Task } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
providers: [Service],
preserveWhitespaces: true,
})
export class AppComponent {
allEmployees: Employee[];
employees: Employee[];
selectedIndex: number;
tasks: Task[];
tasksDataSourceStorage: any;
constructor(private service: Service) {
this.allEmployees = service.getEmployees();
this.employees = service.getEmployees().slice(0, 3);
this.selectedIndex = 0;
this.tasks = service.getTasks();
this.tasksDataSourceStorage = [];
}
onTabDragStart(e) {
e.itemData = e.fromData[e.fromIndex];
}
onTabDrop(e) {
e.fromData.splice(e.fromIndex, 1);
e.toData.splice(e.toIndex, 0, e.itemData);
}
addButtonHandler() {
const newItem = this.allEmployees.filter((employee) => this.employees.indexOf(employee) === -1)[0];
this.selectedIndex = this.employees.length;
this.employees.push(newItem);
}
closeButtonHandler(itemData) {
const index = this.employees.indexOf(itemData);
this.employees.splice(index, 1);
if (index >= this.employees.length && index > 0) this.selectedIndex = index - 1;
}
showCloseButton() {
return this.employees.length > 1;
}
disableButton() {
return this.employees.length === this.allEmployees.length;
}
getTasks(id) {
let item = this.tasksDataSourceStorage.find((i) => i.key === id);
if (!item) {
item = {
key: id,
dataSourceInstance: this.tasks.filter((task) => task.EmployeeID === id),
};
this.tasksDataSourceStorage.push(item);
}
return item.dataSourceInstance;
}
getCompletedTasks(id) {
return this.tasks.filter((task) => task.EmployeeID === id).filter((task) => task.Status === 'Completed');
}
}
@NgModule({
imports: [
BrowserModule,
DxButtonModule,
DxSortableModule,
DxTabPanelModule,
DxListModule,
DxTemplateModule,
],
declarations: [AppComponent],
bootstrap: [AppComponent],
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep #container {
display: flex;
justify-content: flex-end;
padding-bottom: 10px;
}
::ng-deep .dx-tabs .dx-tabs-wrapper .dx-item.dx-tab {
width: auto;
padding-left: 20px;
}
::ng-deep .dx-tab-content .dx-icon.dx-icon-close {
display: inline-block;
opacity: 0.6;
margin-right: 0;
margin-left: 7px;
font-size: 18px;
}
::ng-deep .dx-sortable-dragging .dx-tab {
box-sizing: border-box;
text-align: center;
}
::ng-deep .employeeInfo .employeePhoto {
height: 100px;
float: left;
padding: 10px 20px 10px 20px;
}
::ng-deep .caption {
padding: 0 0 10px 30px;
font-size: 14px;
font-weight: bold;
}
::ng-deep .task-list {
padding: 0 20px;
}
::ng-deep .task-list .dx-state-disabled {
opacity: 1;
}
::ng-deep .task-list .dx-state-disabled .dx-list-item {
opacity: 1;
}
::ng-deep .employeeInfo .employeeNotes {
min-height: 100px;
padding: 20px;
text-align: justify;
white-space: normal;
}
::ng-deep .dx-theme-generic .dx-tabs-wrapper .dx-item.dx-tab {
padding-left: 14px;
padding-right: 9px;
line-height: 1.618;
}
::ng-deep .dx-theme-generic .dx-icon.dx-icon-close {
font-size: 15px;
}
::ng-deep .dx-theme-material .dx-tab-content span {
vertical-align: middle;
line-height: initial;
}
::ng-deep .dx-theme-material .employeeNotes {
margin: 0;
}
import { Injectable } from '@angular/core';
export class Task {
ID: number;
Subject: string;
StartDate: string;
DueDate: string;
Status: string;
Priority: string;
Completion: number;
EmployeeID: number;
}
export class Employee {
ID: number;
FirstName: string;
LastName: string;
Prefix: string;
Position: string;
Picture: string;
BirthDate: string;
HireDate: string;
Notes: string;
Address: string;
State: string;
City: string;
}
const employees: Employee[] = [{
ID: 1,
FirstName: 'John',
LastName: 'Heart',
Prefix: 'Mr.',
Position: 'CEO',
Picture: '../../../../images/employees/01.png',
BirthDate: '1964/03/16',
HireDate: '1995/01/15',
Notes: 'John has been in the Audio/Video industry since 1990. He has led DevAv as its CEO since 2003. When not working hard as the CEO, John loves to golf and bowl. He once bowled a perfect game of 300.',
Address: '351 S Hill St.',
State: 'California',
City: 'Los Angeles',
}, {
ID: 2,
FirstName: 'Olivia',
LastName: 'Peyton',
Prefix: 'Mrs.',
Position: 'Sales Assistant',
Picture: '../../../../images/employees/09.png',
BirthDate: '1981/06/03',
HireDate: '2012/05/14',
Notes: 'Olivia loves to sell. She has been selling DevAV products since 2012. Olivia was homecoming queen in high school. She is expecting her first child in 6 months. Good Luck Olivia.',
Address: '807 W Paseo Del Mar',
State: 'California',
City: 'Los Angeles',
}, {
ID: 3,
FirstName: 'Robert',
LastName: 'Reagan',
Prefix: 'Mr.',
Position: 'CMO',
Picture: '../../../../images/employees/03.png',
BirthDate: '1974/09/07',
HireDate: '2002/11/08',
Notes: 'Robert was recently voted the CMO of the year by CMO Magazine. He is a proud member of the DevAV Management Team. Robert is a championship BBQ chef, so when you get the chance ask him for his secret recipe.',
Address: '4 Westmoreland Pl.',
State: 'Arkansas',
City: 'Bentonville',
}, {
ID: 4,
FirstName: 'Greta',
LastName: 'Sims',
Prefix: 'Ms.',
Position: 'HR Manager',
Picture: '../../../../images/employees/04.png',
BirthDate: '1977/11/22',
HireDate: '1998/04/23',
Notes: 'Greta has been DevAV\'s HR Manager since 2003. She joined DevAV from Sonee Corp. Greta is currently training for the NYC marathon. Her best marathon time is 4 hours. Go Greta.',
Address: '1700 S Grandview Dr.',
State: 'Georgia',
City: 'Atlanta',
}, {
ID: 5,
FirstName: 'Brett',
LastName: 'Wade',
Prefix: 'Mr.',
Position: 'IT Manager',
Picture: '../../../../images/employees/05.png',
BirthDate: '1968/12/01',
HireDate: '2009/03/06',
Notes: 'Brett came to DevAv from Microsoft and has led our IT department since 2012. When he is not working hard for DevAV, he coaches Little League (he was a high school pitcher).',
Address: '1120 Old Mill Rd.',
State: 'Idaho',
City: 'Boise',
}, {
ID: 6,
FirstName: 'Sandra',
LastName: 'Johnson',
Prefix: 'Mrs.',
Position: 'Controller',
Picture: '../../../../images/employees/06.png',
BirthDate: '1974/11/15',
HireDate: '2005/05/11',
Notes: 'Sandra is a CPA and has been our controller since 2008. She loves to interact with staff so if you\'ve not met her, be certain to say hi. Sandra has 2 daughters both of whom are accomplished gymnasts.',
Address: '4600 N Virginia Rd.',
State: 'Utah',
City: 'Beaver',
}, {
ID: 7,
FirstName: 'Kevin',
LastName: 'Carter',
Prefix: 'Mr.',
Position: 'Shipping Manager',
Picture: '../../../../images/employees/07.png',
BirthDate: '1978/01/09',
HireDate: '2009/08/11',
Notes: 'Kevin is our hard-working shipping manager and has been helping that department work like clockwork for 18 months. When not in the office, he is usually on the basketball court playing pick-up games.',
Address: '424 N Main St.',
State: 'California',
City: 'San Diego',
}, {
ID: 8,
FirstName: 'Cynthia',
LastName: 'Stanwick',
Prefix: 'Ms.',
Position: 'HR Assistant',
Picture: '../../../../images/employees/08.png',
BirthDate: '1985/06/05',
HireDate: '2008/03/24',
Notes: 'Cindy joined us in 2008 and has been in the HR department for 2 years. She was recently awarded employee of the month. Way to go Cindy!',
Address: '2211 Bonita Dr.',
State: 'Arkansas',
City: 'Little Rock',
}, {
ID: 9,
FirstName: 'Kent',
LastName: 'Samuelson',
Prefix: 'Dr.',
Position: 'Ombudsman',
Picture: '../../../../images/employees/02.png',
BirthDate: '1972/09/11',
HireDate: '2009/04/22',
Notes: 'As our ombudsman, Kent is on the front-lines solving customer problems and helping our partners address issues out in the field. He is a classically trained musician and is a member of the Chamber Orchestra.',
Address: '12100 Mora Dr',
State: 'Missouri',
City: 'St. Louis',
}];
const tasks: Task[] = [{
ID: 1,
Subject: 'Prepare 2013 Financial',
StartDate: '2013/01/15',
DueDate: '2013/01/31',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 8,
},
{
ID: 2,
Subject: 'Prepare 3013 Marketing Plan',
StartDate: '2013/01/01',
DueDate: '2013/01/31',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 5,
},
{
ID: 3,
Subject: 'Update Personnel Files',
StartDate: '2013/02/03',
DueDate: '2013/02/28',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 2,
},
{
ID: 4,
Subject: 'Review Health Insurance Options Under the Affordable Care Act',
StartDate: '2013/02/12',
DueDate: '2013/04/25',
Status: 'In Progress',
Priority: 'High',
Completion: 50,
EmployeeID: 2,
},
{
ID: 5,
Subject: 'Choose between PPO and HMO Health Plan',
StartDate: '2013/02/15',
DueDate: '2013/04/15',
Status: 'In Progress',
Priority: 'High',
Completion: 75,
EmployeeID: 1,
},
{
ID: 6,
Subject: 'Google AdWords Strategy',
StartDate: '2013/02/16',
DueDate: '2013/02/28',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 1,
},
{
ID: 7,
Subject: 'New Brochures',
StartDate: '2013/02/17',
DueDate: '2013/02/24',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 1,
},
{
ID: 11,
Subject: 'Rollout of New Website and Marketing Brochures',
StartDate: '2013/02/20',
DueDate: '2013/02/28',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 5,
},
{
ID: 12,
Subject: 'Update Sales Strategy Documents',
StartDate: '2013/02/20',
DueDate: '2013/02/22',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 9,
},
{
ID: 15,
Subject: 'Review 2012 Sales Report and Approve 2013 Plans',
StartDate: '2013/02/23',
DueDate: '2013/02/28',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 5,
},
{
ID: 16,
Subject: 'Deliver R&D Plans for 2013',
StartDate: '2013/03/01',
DueDate: '2013/03/10',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 3,
},
{
ID: 20,
Subject: 'Approve Hiring of John Jeffers',
StartDate: '2013/03/02',
DueDate: '2013/03/12',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 4,
},
{
ID: 20,
Subject: 'Approve Hiring of John Jeffers',
StartDate: '2013/03/02',
DueDate: '2013/03/12',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 6,
},
{
ID: 21,
Subject: 'Non-Compete Agreements',
StartDate: '2013/03/12',
DueDate: '2013/03/14',
Status: 'Completed',
Priority: 'Low',
Completion: 100,
EmployeeID: 2,
},
{
ID: 22,
Subject: 'Update NDA Agreement',
StartDate: '2013/03/14',
DueDate: '2013/03/16',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 1,
},
{
ID: 23,
Subject: 'Update Employee Files with New NDA',
StartDate: '2013/03/16',
DueDate: '2013/03/26',
Status: 'Need Assistance',
Priority: 'Normal',
Completion: 90,
EmployeeID: 4,
},
{
ID: 24,
Subject: 'Update Employee Files with New NDA',
StartDate: '2013/03/16',
DueDate: '2013/03/26',
Status: 'Need Assistance',
Priority: 'Normal',
Completion: 90,
EmployeeID: 6,
},
{
ID: 25,
Subject: 'Sign Updated NDA',
StartDate: '2013/03/20',
DueDate: '2013/03/25',
Status: 'Completed',
Priority: 'Urgent',
Completion: 100,
EmployeeID: 7,
},
{
ID: 26,
Subject: 'Sign Updated NDA',
StartDate: '2013/03/20',
DueDate: '2013/03/25',
Status: 'Completed',
Priority: 'Urgent',
Completion: 100,
EmployeeID: 8,
},
{
ID: 27,
Subject: 'Sign Updated NDA',
StartDate: '2013/03/20',
DueDate: '2013/03/25',
Status: 'Need Assistance',
Priority: 'Urgent',
Completion: 25,
EmployeeID: 9,
},
{
ID: 35,
Subject: 'Update Revenue Projections',
StartDate: '2013/03/24',
DueDate: '2013/04/07',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 8,
},
{
ID: 36,
Subject: 'Review Revenue Projections',
StartDate: '2013/03/25',
DueDate: '2013/04/06',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 9,
},
{
ID: 40,
Subject: 'Provide New Health Insurance Docs',
StartDate: '2013/03/28',
DueDate: '2013/04/07',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 4,
},
{
ID: 41,
Subject: 'Provide New Health Insurance Docs',
StartDate: '2013/03/28',
DueDate: '2013/04/07',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 6,
},
{
ID: 50,
Subject: 'Give Final Approval for Refunds',
StartDate: '2013/05/05',
DueDate: '2013/05/15',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 2,
},
{
ID: 52,
Subject: 'Review Product Recall Report by Engineering Team',
StartDate: '2013/05/17',
DueDate: '2013/05/20',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 1,
},
{
ID: 55,
Subject: 'Review Overtime Report',
StartDate: '2013/06/10',
DueDate: '2013/06/14',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 7,
},
{
ID: 60,
Subject: 'Refund Request Template',
StartDate: '2013/06/17',
DueDate: '2014/04/01',
Status: 'Deferred',
Priority: 'Normal',
Completion: 0,
EmployeeID: 9,
},
{
ID: 71,
Subject: 'Upgrade Server Hardware',
StartDate: '2013/07/22',
DueDate: '2013/07/31',
Status: 'Completed',
Priority: 'Urgent',
Completion: 100,
EmployeeID: 7,
},
{
ID: 72,
Subject: 'Upgrade Personal Computers',
StartDate: '2013/07/24',
DueDate: '2014/04/30',
Status: 'In Progress',
Priority: 'Normal',
Completion: 85,
EmployeeID: 7,
},
{
ID: 74,
Subject: 'Decide on Mobile Devices to Use in the Field',
StartDate: '2013/07/30',
DueDate: '2013/08/02',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 3,
},
{
ID: 78,
Subject: 'Try New Touch-Enabled WinForms Apps',
StartDate: '2013/08/11',
DueDate: '2013/08/15',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 3,
},
{
ID: 81,
Subject: 'Review Site Up-Time Report',
StartDate: '2013/08/24',
DueDate: '2013/08/30',
Status: 'Completed',
Priority: 'Urgent',
Completion: 100,
EmployeeID: 5,
},
{
ID: 99,
Subject: 'Submit D&B Number to ISP for Credit Approval',
StartDate: '2013/11/04',
DueDate: '2013/11/07',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 8,
},
{
ID: 117,
Subject: 'Approval on Converting to New HDMI Specification',
StartDate: '2014/01/11',
DueDate: '2014/01/31',
Status: 'Deferred',
Priority: 'Normal',
Completion: 75,
EmployeeID: 3,
},
{
ID: 138,
Subject: 'Review HR Budget Company Wide',
StartDate: '2014/03/20',
DueDate: '2014/03/25',
Status: 'In Progress',
Priority: 'Normal',
Completion: 40,
EmployeeID: 6,
},
{
ID: 145,
Subject: 'Final Budget Review',
StartDate: '2014/03/26',
DueDate: '2014/03/27',
Status: 'In Progress',
Priority: 'High',
Completion: 25,
EmployeeID: 6,
}];
@Injectable()
export class Service {
getEmployees() {
return employees;
}
getTasks() {
return tasks;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'ts': 'npm:plugin-typescript@4.2.4/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'@angular/core': 'npm:@angular/core@12.2.17',
'@angular/platform-browser': 'npm:@angular/platform-browser@12.2.17',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic@12.2.17',
'@angular/forms': 'npm:@angular/forms@12.2.17',
'@angular/common': 'npm:@angular/common@12.2.17',
'@angular/compiler': 'npm:@angular/compiler@12.2.17',
'tslib': 'npm:tslib@2.3.1/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.2.5/cjs',
'devextreme/bundles/dx.all': 'npm:devextreme@22.2.5/bundles/dx.all.js',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.20/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.72',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.42',
'devextreme-angular': 'npm:devextreme-angular@22.2.5',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.4/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.11/inferno/package.json',
'npm:@angular/*/package.json',
'npm:@angular/common@12.2.17/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devextreme-angular@22.2.5/*/package.json',
'npm:devextreme-angular@22.2.5/ui/*/package.json',
'npm:devextreme-angular@22.2.5/package.json',
'npm:devexpress-diagram@2.1.72/package.json',
'npm:devexpress-gantt@4.1.42/package.json',
],
};
System.config(window.config);
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.5/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.12.0/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

import React from 'react';
import { Button } from 'devextreme-react';
import { Sortable } from 'devextreme-react/sortable';
import TabPanel from 'devextreme-react/tab-panel';
import 'devextreme/data/odata/store';
import service from './data.js';
import EmployeeTemplate from './EmployeeTemplate.js';
const allEmployees = service.getEmployees();
function App() {
const [employees, setEmployees] = React.useState(allEmployees.slice(0, 3));
const [selectedItem, setSelectedItem] = React.useState(allEmployees[0]);
const addButtonHandler = React.useCallback(() => {
const newItem = allEmployees
.filter((employee) => employees.indexOf(employee) === -1)[0];
setEmployees([...employees, newItem]);
setSelectedItem(newItem);
}, [employees, setEmployees, setSelectedItem]);
function disableButton() {
return employees.length === allEmployees.length;
}
const closeButtonHandler = React.useCallback((item) => {
const newEmployees = [...employees];
const index = newEmployees.indexOf(item);
newEmployees.splice(index, 1);
setEmployees(newEmployees);
if (index >= newEmployees.length && index > 0) {
setSelectedItem(newEmployees[index - 1]);
}
}, [employees, setEmployees, setSelectedItem]);
const renderTitle = React.useCallback((data) => (
<React.Fragment>
<div>
<span>
{data.FirstName} {data.LastName}
</span>
{employees.length >= 2 && <i className="dx-icon dx-icon-close" onClick={() => { closeButtonHandler(data); }} />}
</div>
</React.Fragment>
), [employees, closeButtonHandler]);
const onSelectionChanged = React.useCallback((args) => {
setSelectedItem(args.addedItems[0]);
}, [setSelectedItem]);
const onTabDragStart = React.useCallback((e) => {
e.itemData = e.fromData[e.fromIndex];
}, []);
const onTabDrop = React.useCallback((e) => {
const newEmployees = [...employees];
newEmployees.splice(e.fromIndex, 1);
newEmployees.splice(e.toIndex, 0, e.itemData);
setEmployees(newEmployees);
}, [employees, setEmployees]);
return (
<React.Fragment>
<div id="container">
<Button
disabled={disableButton()}
text="Add Tab"
icon="add"
type="default"
onClick={addButtonHandler}
/>
</div>
<Sortable
filter=".dx-tab"
data={employees}
itemOrientation="horizontal"
dragDirection="horizontal"
onDragStart={onTabDragStart}
onReorder={onTabDrop}
>
<TabPanel
dataSource={employees}
height={410}
itemTitleRender={renderTitle}
deferRendering={false}
showNavButtons={true}
selectedItem={selectedItem}
repaintChangesOnly={true}
onSelectionChanged={onSelectionChanged}
itemComponent={EmployeeTemplate}
/>
</Sortable>
</React.Fragment>
);
}
export default App;
import React from 'react';
import { List } from 'devextreme-react/list';
import service from './data.js';
function itemRender(data) {
return <div>{data.Subject}</div>;
}
function EmployeeTemplate(props) {
const tasks = service
.getTasks()
.filter((task) => task.EmployeeID === props.data.ID);
const {
FirstName, LastName, Picture, Position, Notes,
} = props.data;
const completedTasks = tasks.filter((task) => task.Status === 'Completed');
return (
<React.Fragment>
<div className="employeeInfo">
<img className="employeePhoto" src={Picture} />
<p className="employeeNotes">
<b>{`Position: ${Position}`}</b>
<br />
{Notes}
</p>
</div>
<div className="caption">{`${FirstName} ${LastName}'s Tasks:`}</div>
<div className="task-list">
<List
dataSource={tasks}
showSelectionControls={true}
selectedItems={completedTasks}
disabled={true}
selectionMode="multiple"
itemRender={itemRender}
></List>
</div>
</React.Fragment>
);
}
export default EmployeeTemplate;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#container {
display: flex;
justify-content: flex-end;
padding-bottom: 10px;
}
.dx-tabs .dx-tabs-wrapper .dx-item.dx-tab {
width: auto;
padding-left: 20px;
}
.dx-tab-content .dx-icon.dx-icon-close {
display: inline-block;
opacity: 0.6;
margin-right: 0;
margin-left: 7px;
font-size: 18px;
}
.dx-sortable-dragging .dx-tab {
box-sizing: border-box;
text-align: center;
}
.employeeInfo .employeePhoto {
height: 100px;
float: left;
padding: 10px 20px 10px 20px;
}
.caption {
padding: 0 0 10px 30px;
font-size: 14px;
font-weight: bold;
}
.task-list {
padding: 0 20px;
}
.task-list .dx-state-disabled {
opacity: 1;
}
.task-list .dx-state-disabled .dx-list-item {
opacity: 1;
}
.employeeInfo .employeeNotes {
min-height: 100px;
padding: 20px;
text-align: justify;
white-space: normal;
}
.dx-theme-generic .dx-tabs-wrapper .dx-item.dx-tab {
padding-left: 14px;
padding-right: 9px;
line-height: 1.618;
}
.dx-theme-generic .dx-icon.dx-icon-close {
font-size: 15px;
}
.dx-theme-material .dx-tab-content span {
vertical-align: middle;
line-height: initial;
}
.dx-theme-material .employeeNotes {
margin: 0;
}
const employees = [{
ID: 1,
FirstName: 'John',
LastName: 'Heart',
Prefix: 'Mr.',
Position: 'CEO',
Picture: '../../../../images/employees/01.png',
BirthDate: '1964/03/16',
HireDate: '1995/01/15',
Notes: 'John has been in the Audio/Video industry since 1990. He has led DevAv as its CEO since 2003. When not working hard as the CEO, John loves to golf and bowl. He once bowled a perfect game of 300.',
Address: '351 S Hill St.',
State: 'California',
City: 'Los Angeles',
}, {
ID: 2,
FirstName: 'Olivia',
LastName: 'Peyton',
Prefix: 'Mrs.',
Position: 'Sales Assistant',
Picture: '../../../../images/employees/09.png',
BirthDate: '1981/06/03',
HireDate: '2012/05/14',
Notes: 'Olivia loves to sell. She has been selling DevAV products since 2012. Olivia was homecoming queen in high school. She is expecting her first child in 6 months. Good Luck Olivia.',
Address: '807 W Paseo Del Mar',
State: 'California',
City: 'Los Angeles',
}, {
ID: 3,
FirstName: 'Robert',
LastName: 'Reagan',
Prefix: 'Mr.',
Position: 'CMO',
Picture: '../../../../images/employees/03.png',
BirthDate: '1974/09/07',
HireDate: '2002/11/08',
Notes: 'Robert was recently voted the CMO of the year by CMO Magazine. He is a proud member of the DevAV Management Team. Robert is a championship BBQ chef, so when you get the chance ask him for his secret recipe.',
Address: '4 Westmoreland Pl.',
State: 'Arkansas',
City: 'Bentonville',
}, {
ID: 4,
FirstName: 'Greta',
LastName: 'Sims',
Prefix: 'Ms.',
Position: 'HR Manager',
Picture: '../../../../images/employees/04.png',
BirthDate: '1977/11/22',
HireDate: '1998/04/23',
Notes: 'Greta has been DevAV\'s HR Manager since 2003. She joined DevAV from Sonee Corp. Greta is currently training for the NYC marathon. Her best marathon time is 4 hours. Go Greta.',
Address: '1700 S Grandview Dr.',
State: 'Georgia',
City: 'Atlanta',
}, {
ID: 5,
FirstName: 'Brett',
LastName: 'Wade',
Prefix: 'Mr.',
Position: 'IT Manager',
Picture: '../../../../images/employees/05.png',
BirthDate: '1968/12/01',
HireDate: '2009/03/06',
Notes: 'Brett came to DevAv from Microsoft and has led our IT department since 2012. When he is not working hard for DevAV, he coaches Little League (he was a high school pitcher).',
Address: '1120 Old Mill Rd.',
State: 'Idaho',
City: 'Boise',
}, {
ID: 6,
FirstName: 'Sandra',
LastName: 'Johnson',
Prefix: 'Mrs.',
Position: 'Controller',
Picture: '../../../../images/employees/06.png',
BirthDate: '1974/11/15',
HireDate: '2005/05/11',
Notes: 'Sandra is a CPA and has been our controller since 2008. She loves to interact with staff so if you\'ve not met her, be certain to say hi. Sandra has 2 daughters both of whom are accomplished gymnasts.',
Address: '4600 N Virginia Rd.',
State: 'Utah',
City: 'Beaver',
}, {
ID: 7,
FirstName: 'Kevin',
LastName: 'Carter',
Prefix: 'Mr.',
Position: 'Shipping Manager',
Picture: '../../../../images/employees/07.png',
BirthDate: '1978/01/09',
HireDate: '2009/08/11',
Notes: 'Kevin is our hard-working shipping manager and has been helping that department work like clockwork for 18 months. When not in the office, he is usually on the basketball court playing pick-up games.',
Address: '424 N Main St.',
State: 'California',
City: 'San Diego',
}, {
ID: 8,
FirstName: 'Cynthia',
LastName: 'Stanwick',
Prefix: 'Ms.',
Position: 'HR Assistant',
Picture: '../../../../images/employees/08.png',
BirthDate: '1985/06/05',
HireDate: '2008/03/24',
Notes: 'Cindy joined us in 2008 and has been in the HR department for 2 years. She was recently awarded employee of the month. Way to go Cindy!',
Address: '2211 Bonita Dr.',
State: 'Arkansas',
City: 'Little Rock',
}, {
ID: 9,
FirstName: 'Kent',
LastName: 'Samuelson',
Prefix: 'Dr.',
Position: 'Ombudsman',
Picture: '../../../../images/employees/02.png',
BirthDate: '1972/09/11',
HireDate: '2009/04/22',
Notes: 'As our ombudsman, Kent is on the front-lines solving customer problems and helping our partners address issues out in the field. He is a classically trained musician and is a member of the Chamber Orchestra.',
Address: '12100 Mora Dr',
State: 'Missouri',
City: 'St. Louis',
}];
const tasks = [{
ID: 1,
Subject: 'Prepare 2013 Financial',
StartDate: '2013/01/15',
DueDate: '2013/01/31',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 8,
},
{
ID: 2,
Subject: 'Prepare 3013 Marketing Plan',
StartDate: '2013/01/01',
DueDate: '2013/01/31',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 5,
},
{
ID: 3,
Subject: 'Update Personnel Files',
StartDate: '2013/02/03',
DueDate: '2013/02/28',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 2,
},
{
ID: 4,
Subject: 'Review Health Insurance Options Under the Affordable Care Act',
StartDate: '2013/02/12',
DueDate: '2013/04/25',
Status: 'In Progress',
Priority: 'High',
Completion: 50,
EmployeeID: 2,
},
{
ID: 5,
Subject: 'Choose between PPO and HMO Health Plan',
StartDate: '2013/02/15',
DueDate: '2013/04/15',
Status: 'In Progress',
Priority: 'High',
Completion: 75,
EmployeeID: 1,
},
{
ID: 6,
Subject: 'Google AdWords Strategy',
StartDate: '2013/02/16',
DueDate: '2013/02/28',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 1,
},
{
ID: 7,
Subject: 'New Brochures',
StartDate: '2013/02/17',
DueDate: '2013/02/24',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 1,
},
{
ID: 11,
Subject: 'Rollout of New Website and Marketing Brochures',
StartDate: '2013/02/20',
DueDate: '2013/02/28',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 5,
},
{
ID: 12,
Subject: 'Update Sales Strategy Documents',
StartDate: '2013/02/20',
DueDate: '2013/02/22',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 9,
},
{
ID: 15,
Subject: 'Review 2012 Sales Report and Approve 2013 Plans',
StartDate: '2013/02/23',
DueDate: '2013/02/28',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 5,
},
{
ID: 16,
Subject: 'Deliver R&D Plans for 2013',
StartDate: '2013/03/01',
DueDate: '2013/03/10',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 3,
},
{
ID: 20,
Subject: 'Approve Hiring of John Jeffers',
StartDate: '2013/03/02',
DueDate: '2013/03/12',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 4,
},
{
ID: 20,
Subject: 'Approve Hiring of John Jeffers',
StartDate: '2013/03/02',
DueDate: '2013/03/12',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 6,
},
{
ID: 21,
Subject: 'Non-Compete Agreements',
StartDate: '2013/03/12',
DueDate: '2013/03/14',
Status: 'Completed',
Priority: 'Low',
Completion: 100,
EmployeeID: 2,
},
{
ID: 22,
Subject: 'Update NDA Agreement',
StartDate: '2013/03/14',
DueDate: '2013/03/16',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 1,
},
{
ID: 23,
Subject: 'Update Employee Files with New NDA',
StartDate: '2013/03/16',
DueDate: '2013/03/26',
Status: 'Need Assistance',
Priority: 'Normal',
Completion: 90,
EmployeeID: 4,
},
{
ID: 24,
Subject: 'Update Employee Files with New NDA',
StartDate: '2013/03/16',
DueDate: '2013/03/26',
Status: 'Need Assistance',
Priority: 'Normal',
Completion: 90,
EmployeeID: 6,
},
{
ID: 25,
Subject: 'Sign Updated NDA',
StartDate: '2013/03/20',
DueDate: '2013/03/25',
Status: 'Completed',
Priority: 'Urgent',
Completion: 100,
EmployeeID: 7,
},
{
ID: 26,
Subject: 'Sign Updated NDA',
StartDate: '2013/03/20',
DueDate: '2013/03/25',
Status: 'Completed',
Priority: 'Urgent',
Completion: 100,
EmployeeID: 8,
},
{
ID: 27,
Subject: 'Sign Updated NDA',
StartDate: '2013/03/20',
DueDate: '2013/03/25',
Status: 'Need Assistance',
Priority: 'Urgent',
Completion: 25,
EmployeeID: 9,
},
{
ID: 35,
Subject: 'Update Revenue Projections',
StartDate: '2013/03/24',
DueDate: '2013/04/07',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 8,
},
{
ID: 36,
Subject: 'Review Revenue Projections',
StartDate: '2013/03/25',
DueDate: '2013/04/06',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 9,
},
{
ID: 40,
Subject: 'Provide New Health Insurance Docs',
StartDate: '2013/03/28',
DueDate: '2013/04/07',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 4,
},
{
ID: 41,
Subject: 'Provide New Health Insurance Docs',
StartDate: '2013/03/28',
DueDate: '2013/04/07',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 6,
},
{
ID: 50,
Subject: 'Give Final Approval for Refunds',
StartDate: '2013/05/05',
DueDate: '2013/05/15',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 2,
},
{
ID: 52,
Subject: 'Review Product Recall Report by Engineering Team',
StartDate: '2013/05/17',
DueDate: '2013/05/20',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 1,
},
{
ID: 55,
Subject: 'Review Overtime Report',
StartDate: '2013/06/10',
DueDate: '2013/06/14',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 7,
},
{
ID: 60,
Subject: 'Refund Request Template',
StartDate: '2013/06/17',
DueDate: '2014/04/01',
Status: 'Deferred',
Priority: 'Normal',
Completion: 0,
EmployeeID: 9,
},
{
ID: 71,
Subject: 'Upgrade Server Hardware',
StartDate: '2013/07/22',
DueDate: '2013/07/31',
Status: 'Completed',
Priority: 'Urgent',
Completion: 100,
EmployeeID: 7,
},
{
ID: 72,
Subject: 'Upgrade Personal Computers',
StartDate: '2013/07/24',
DueDate: '2014/04/30',
Status: 'In Progress',
Priority: 'Normal',
Completion: 85,
EmployeeID: 7,
},
{
ID: 74,
Subject: 'Decide on Mobile Devices to Use in the Field',
StartDate: '2013/07/30',
DueDate: '2013/08/02',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 3,
},
{
ID: 78,
Subject: 'Try New Touch-Enabled WinForms Apps',
StartDate: '2013/08/11',
DueDate: '2013/08/15',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 3,
},
{
ID: 81,
Subject: 'Review Site Up-Time Report',
StartDate: '2013/08/24',
DueDate: '2013/08/30',
Status: 'Completed',
Priority: 'Urgent',
Completion: 100,
EmployeeID: 5,
},
{
ID: 99,
Subject: 'Submit D&B Number to ISP for Credit Approval',
StartDate: '2013/11/04',
DueDate: '2013/11/07',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 8,
},
{
ID: 117,
Subject: 'Approval on Converting to New HDMI Specification',
StartDate: '2014/01/11',
DueDate: '2014/01/31',
Status: 'Deferred',
Priority: 'Normal',
Completion: 75,
EmployeeID: 3,
},
{
ID: 138,
Subject: 'Review HR Budget Company Wide',
StartDate: '2014/03/20',
DueDate: '2014/03/25',
Status: 'In Progress',
Priority: 'Normal',
Completion: 40,
EmployeeID: 6,
},
{
ID: 145,
Subject: 'Final Budget Review',
StartDate: '2014/03/26',
DueDate: '2014/03/27',
Status: 'In Progress',
Priority: 'High',
Completion: 25,
EmployeeID: 6,
}];
export default {
getEmployees() {
return employees;
},
getTasks() {
return tasks;
},
};
window.config = {
transpiler: 'plugin-babel',
meta: {
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
defaultExtension: 'js',
map: {
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.8.1/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.2.3/cjs',
'devextreme-react': 'npm:devextreme-react@22.2.3',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.18/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.65/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.37/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.7.1/standalone.js',
'prettier/parser-html': 'npm:prettier@2.7.1/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.11/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);

<template>
<div>
<div id="container">
<DxButton
:disabled="disableButton()"
text="Add Tab"
icon="add"
type="default"
@click="addButtonHandler"
/>
</div>
<DxSortable
filter=".dx-tab"
v-model:data="employees"
item-orientation="horizontal"
drag-direction="horizontal"
@drag-start="onTabDragStart($event)"
@reorder="onTabDrop($event)"
>
<div>
<DxTabPanel
v-model:data-source="employees"
:height="410"
:defer-rendering="false"
:show-nav-buttons="true"
:repaint-changes-only="true"
v-model:selected-index="selectedIndex"
item-title-template="title"
item-template="itemTemplate"
>
<template #title="{ data: employee }">
<div>
<span>{{ employee.FirstName }} {{ employee.LastName }}</span><i
v-show="showCloseButton()"
class="dx-icon dx-icon-close"
@click="closeButtonHandler(employee)"
/>
</div>
</template>
<template #itemTemplate="{ data: employee }">
<EmployeeTemplate
:template-data="employee"
/>
</template>
</DxTabPanel>
</div>
</DxSortable>
</div>
</template>
<script>
import DxSortable from 'devextreme-vue/sortable';
import DxButton from 'devextreme-vue/button';
import DxTabPanel from 'devextreme-vue/tab-panel';
import { DxDataGrid } from 'devextreme-vue/data-grid';
import EmployeeTemplate from './EmployeeTemplate.vue';
import service from './data.js';
const allEmployees = service.getEmployees();
export default {
components: {
DxButton,
DxTabPanel,
DxDataGrid,
DxSortable,
EmployeeTemplate,
},
data() {
return {
employees: allEmployees.slice(0, 3),
selectedIndex: 0,
};
},
methods: {
onTabDragStart(e) {
e.itemData = e.fromData[e.fromIndex];
},
onTabDrop(e) {
const newEmployees = [...this.employees];
newEmployees.splice(e.fromIndex, 1);
newEmployees.splice(e.toIndex, 0, e.itemData);
this.employees = newEmployees;
},
addButtonHandler() {
const newItem = allEmployees
.filter((employee) => this.employees.every((item) => employee.ID !== item.ID))[0];
this.selectedIndex = this.employees.length;
this.employees = [...this.employees, newItem];
},
closeButtonHandler(itemData) {
const index = this.employees.indexOf(itemData);
this.employees = this.employees.filter((e) => e !== itemData);
if (index >= this.employees.length && index > 0) this.selectedIndex = index - 1;
},
disableButton() {
return this.employees.length === allEmployees.length;
},
showCloseButton() {
return this.employees.length > 1;
},
},
};
</script>
<style>
#container {
display: flex;
justify-content: flex-end;
padding-bottom: 10px;
}
.dx-tabs .dx-tabs-wrapper .dx-item.dx-tab {
width: auto;
padding-left: 20px;
}
.dx-tab-content .dx-icon.dx-icon-close {
display: inline-block;
opacity: 0.6;
margin-right: 0;
margin-left: 7px;
font-size: 18px;
}
.dx-sortable-dragging .dx-tab {
box-sizing: border-box;
text-align: center;
}
.employeeInfo .employeePhoto {
height: 100px;
float: left;
padding: 10px 20px 10px 20px;
}
.employeeInfo .employeeNotes {
min-height: 100px;
padding: 20px;
text-align: justify;
white-space: normal;
}
.dx-theme-generic .dx-tabs-wrapper .dx-item.dx-tab {
padding-left: 14px;
padding-right: 9px;
line-height: 1.618;
}
.dx-theme-generic .dx-icon.dx-icon-close {
font-size: 15px;
}
.dx-theme-material .dx-tab-content span {
vertical-align: middle;
line-height: initial;
}
.dx-theme-material .employeeNotes {
margin: 0;
}
</style>
<template>
<div>
<div class="employeeInfo">
<img
class="employeePhoto"
:alt="FirstName + ' ' + LastName"
:src="picture"
>
<p class="employeeNotes"><b>Position: {{ position }}</b><br>{{ notes }}</p>
</div>
<div class="caption">{{ detailInfo }}</div>
<div class="task-list">
<DxList
:data-source="dataSource"
:show-selection-controls="true"
:selected-items="completedTasks"
:disabled="true"
selection-mode="multiple"
>
<template #item="{ data: item }">
<div>
{{ item.Subject }}
</div>
</template>
</DxList>
</div>
</div>
</template>
<script>
import DxList from 'devextreme-vue/list';
import service from './data.js';
const tasks = service.getTasks();
export default {
components: { DxList },
props: {
templateData: {
type: Object,
default: () => {},
},
},
data() {
const {
FirstName, LastName, Picture, Position, Notes,
} = this.templateData;
const employeeTasks = tasks.filter((task) => task.EmployeeID === this.templateData.ID);
return {
dataSource: employeeTasks,
completedTasks: employeeTasks.filter((task) => task.Status === 'Completed'),
detailInfo: `${FirstName} ${LastName}'s Tasks:`,
picture: Picture,
position: Position,
notes: Notes,
};
},
};
</script>
<style>
.caption {
padding: 0 0 10px 30px;
font-size: 14px;
font-weight: bold;
}
.task-list {
padding: 0 20px;
}
.task-list .dx-state-disabled {
opacity: 1;
}
.task-list .dx-state-disabled .dx-list-item {
opacity: 1;
}
</style>
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.1.5/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
const employees = [{
ID: 1,
FirstName: 'John',
LastName: 'Heart',
Prefix: 'Mr.',
Position: 'CEO',
Picture: '../../../../images/employees/01.png',
BirthDate: '1964/03/16',
HireDate: '1995/01/15',
Notes: 'John has been in the Audio/Video industry since 1990. He has led DevAv as its CEO since 2003. When not working hard as the CEO, John loves to golf and bowl. He once bowled a perfect game of 300.',
Address: '351 S Hill St.',
State: 'California',
City: 'Los Angeles',
}, {
ID: 2,
FirstName: 'Olivia',
LastName: 'Peyton',
Prefix: 'Mrs.',
Position: 'Sales Assistant',
Picture: '../../../../images/employees/09.png',
BirthDate: '1981/06/03',
HireDate: '2012/05/14',
Notes: 'Olivia loves to sell. She has been selling DevAV products since 2012. Olivia was homecoming queen in high school. She is expecting her first child in 6 months. Good Luck Olivia.',
Address: '807 W Paseo Del Mar',
State: 'California',
City: 'Los Angeles',
}, {
ID: 3,
FirstName: 'Robert',
LastName: 'Reagan',
Prefix: 'Mr.',
Position: 'CMO',
Picture: '../../../../images/employees/03.png',
BirthDate: '1974/09/07',
HireDate: '2002/11/08',
Notes: 'Robert was recently voted the CMO of the year by CMO Magazine. He is a proud member of the DevAV Management Team. Robert is a championship BBQ chef, so when you get the chance ask him for his secret recipe.',
Address: '4 Westmoreland Pl.',
State: 'Arkansas',
City: 'Bentonville',
}, {
ID: 4,
FirstName: 'Greta',
LastName: 'Sims',
Prefix: 'Ms.',
Position: 'HR Manager',
Picture: '../../../../images/employees/04.png',
BirthDate: '1977/11/22',
HireDate: '1998/04/23',
Notes: 'Greta has been DevAV\'s HR Manager since 2003. She joined DevAV from Sonee Corp. Greta is currently training for the NYC marathon. Her best marathon time is 4 hours. Go Greta.',
Address: '1700 S Grandview Dr.',
State: 'Georgia',
City: 'Atlanta',
}, {
ID: 5,
FirstName: 'Brett',
LastName: 'Wade',
Prefix: 'Mr.',
Position: 'IT Manager',
Picture: '../../../../images/employees/05.png',
BirthDate: '1968/12/01',
HireDate: '2009/03/06',
Notes: 'Brett came to DevAv from Microsoft and has led our IT department since 2012. When he is not working hard for DevAV, he coaches Little League (he was a high school pitcher).',
Address: '1120 Old Mill Rd.',
State: 'Idaho',
City: 'Boise',
}, {
ID: 6,
FirstName: 'Sandra',
LastName: 'Johnson',
Prefix: 'Mrs.',
Position: 'Controller',
Picture: '../../../../images/employees/06.png',
BirthDate: '1974/11/15',
HireDate: '2005/05/11',
Notes: 'Sandra is a CPA and has been our controller since 2008. She loves to interact with staff so if you\'ve not met her, be certain to say hi. Sandra has 2 daughters both of whom are accomplished gymnasts.',
Address: '4600 N Virginia Rd.',
State: 'Utah',
City: 'Beaver',
}, {
ID: 7,
FirstName: 'Kevin',
LastName: 'Carter',
Prefix: 'Mr.',
Position: 'Shipping Manager',
Picture: '../../../../images/employees/07.png',
BirthDate: '1978/01/09',
HireDate: '2009/08/11',
Notes: 'Kevin is our hard-working shipping manager and has been helping that department work like clockwork for 18 months. When not in the office, he is usually on the basketball court playing pick-up games.',
Address: '424 N Main St.',
State: 'California',
City: 'San Diego',
}, {
ID: 8,
FirstName: 'Cynthia',
LastName: 'Stanwick',
Prefix: 'Ms.',
Position: 'HR Assistant',
Picture: '../../../../images/employees/08.png',
BirthDate: '1985/06/05',
HireDate: '2008/03/24',
Notes: 'Cindy joined us in 2008 and has been in the HR department for 2 years. She was recently awarded employee of the month. Way to go Cindy!',
Address: '2211 Bonita Dr.',
State: 'Arkansas',
City: 'Little Rock',
}, {
ID: 9,
FirstName: 'Kent',
LastName: 'Samuelson',
Prefix: 'Dr.',
Position: 'Ombudsman',
Picture: '../../../../images/employees/02.png',
BirthDate: '1972/09/11',
HireDate: '2009/04/22',
Notes: 'As our ombudsman, Kent is on the front-lines solving customer problems and helping our partners address issues out in the field. He is a classically trained musician and is a member of the Chamber Orchestra.',
Address: '12100 Mora Dr',
State: 'Missouri',
City: 'St. Louis',
}];
const tasks = [{
ID: 1,
Subject: 'Prepare 2013 Financial',
StartDate: '2013/01/15',
DueDate: '2013/01/31',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 8,
},
{
ID: 2,
Subject: 'Prepare 3013 Marketing Plan',
StartDate: '2013/01/01',
DueDate: '2013/01/31',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 5,
},
{
ID: 3,
Subject: 'Update Personnel Files',
StartDate: '2013/02/03',
DueDate: '2013/02/28',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 2,
},
{
ID: 4,
Subject: 'Review Health Insurance Options Under the Affordable Care Act',
StartDate: '2013/02/12',
DueDate: '2013/04/25',
Status: 'In Progress',
Priority: 'High',
Completion: 50,
EmployeeID: 2,
},
{
ID: 5,
Subject: 'Choose between PPO and HMO Health Plan',
StartDate: '2013/02/15',
DueDate: '2013/04/15',
Status: 'In Progress',
Priority: 'High',
Completion: 75,
EmployeeID: 1,
},
{
ID: 6,
Subject: 'Google AdWords Strategy',
StartDate: '2013/02/16',
DueDate: '2013/02/28',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 1,
},
{
ID: 7,
Subject: 'New Brochures',
StartDate: '2013/02/17',
DueDate: '2013/02/24',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 1,
},
{
ID: 11,
Subject: 'Rollout of New Website and Marketing Brochures',
StartDate: '2013/02/20',
DueDate: '2013/02/28',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 5,
},
{
ID: 12,
Subject: 'Update Sales Strategy Documents',
StartDate: '2013/02/20',
DueDate: '2013/02/22',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 9,
},
{
ID: 15,
Subject: 'Review 2012 Sales Report and Approve 2013 Plans',
StartDate: '2013/02/23',
DueDate: '2013/02/28',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 5,
},
{
ID: 16,
Subject: 'Deliver R&D Plans for 2013',
StartDate: '2013/03/01',
DueDate: '2013/03/10',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 3,
},
{
ID: 20,
Subject: 'Approve Hiring of John Jeffers',
StartDate: '2013/03/02',
DueDate: '2013/03/12',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 4,
},
{
ID: 20,
Subject: 'Approve Hiring of John Jeffers',
StartDate: '2013/03/02',
DueDate: '2013/03/12',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 6,
},
{
ID: 21,
Subject: 'Non-Compete Agreements',
StartDate: '2013/03/12',
DueDate: '2013/03/14',
Status: 'Completed',
Priority: 'Low',
Completion: 100,
EmployeeID: 2,
},
{
ID: 22,
Subject: 'Update NDA Agreement',
StartDate: '2013/03/14',
DueDate: '2013/03/16',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 1,
},
{
ID: 23,
Subject: 'Update Employee Files with New NDA',
StartDate: '2013/03/16',
DueDate: '2013/03/26',
Status: 'Need Assistance',
Priority: 'Normal',
Completion: 90,
EmployeeID: 4,
},
{
ID: 24,
Subject: 'Update Employee Files with New NDA',
StartDate: '2013/03/16',
DueDate: '2013/03/26',
Status: 'Need Assistance',
Priority: 'Normal',
Completion: 90,
EmployeeID: 6,
},
{
ID: 25,
Subject: 'Sign Updated NDA',
StartDate: '2013/03/20',
DueDate: '2013/03/25',
Status: 'Completed',
Priority: 'Urgent',
Completion: 100,
EmployeeID: 7,
},
{
ID: 26,
Subject: 'Sign Updated NDA',
StartDate: '2013/03/20',
DueDate: '2013/03/25',
Status: 'Completed',
Priority: 'Urgent',
Completion: 100,
EmployeeID: 8,
},
{
ID: 27,
Subject: 'Sign Updated NDA',
StartDate: '2013/03/20',
DueDate: '2013/03/25',
Status: 'Need Assistance',
Priority: 'Urgent',
Completion: 25,
EmployeeID: 9,
},
{
ID: 35,
Subject: 'Update Revenue Projections',
StartDate: '2013/03/24',
DueDate: '2013/04/07',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 8,
},
{
ID: 36,
Subject: 'Review Revenue Projections',
StartDate: '2013/03/25',
DueDate: '2013/04/06',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 9,
},
{
ID: 40,
Subject: 'Provide New Health Insurance Docs',
StartDate: '2013/03/28',
DueDate: '2013/04/07',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 4,
},
{
ID: 41,
Subject: 'Provide New Health Insurance Docs',
StartDate: '2013/03/28',
DueDate: '2013/04/07',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 6,
},
{
ID: 50,
Subject: 'Give Final Approval for Refunds',
StartDate: '2013/05/05',
DueDate: '2013/05/15',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 2,
},
{
ID: 52,
Subject: 'Review Product Recall Report by Engineering Team',
StartDate: '2013/05/17',
DueDate: '2013/05/20',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 1,
},
{
ID: 55,
Subject: 'Review Overtime Report',
StartDate: '2013/06/10',
DueDate: '2013/06/14',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 7,
},
{
ID: 60,
Subject: 'Refund Request Template',
StartDate: '2013/06/17',
DueDate: '2014/04/01',
Status: 'Deferred',
Priority: 'Normal',
Completion: 0,
EmployeeID: 9,
},
{
ID: 71,
Subject: 'Upgrade Server Hardware',
StartDate: '2013/07/22',
DueDate: '2013/07/31',
Status: 'Completed',
Priority: 'Urgent',
Completion: 100,
EmployeeID: 7,
},
{
ID: 72,
Subject: 'Upgrade Personal Computers',
StartDate: '2013/07/24',
DueDate: '2014/04/30',
Status: 'In Progress',
Priority: 'Normal',
Completion: 85,
EmployeeID: 7,
},
{
ID: 74,
Subject: 'Decide on Mobile Devices to Use in the Field',
StartDate: '2013/07/30',
DueDate: '2013/08/02',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 3,
},
{
ID: 78,
Subject: 'Try New Touch-Enabled WinForms Apps',
StartDate: '2013/08/11',
DueDate: '2013/08/15',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 3,
},
{
ID: 81,
Subject: 'Review Site Up-Time Report',
StartDate: '2013/08/24',
DueDate: '2013/08/30',
Status: 'Completed',
Priority: 'Urgent',
Completion: 100,
EmployeeID: 5,
},
{
ID: 99,
Subject: 'Submit D&B Number to ISP for Credit Approval',
StartDate: '2013/11/04',
DueDate: '2013/11/07',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 8,
},
{
ID: 117,
Subject: 'Approval on Converting to New HDMI Specification',
StartDate: '2014/01/11',
DueDate: '2014/01/31',
Status: 'Deferred',
Priority: 'Normal',
Completion: 75,
EmployeeID: 3,
},
{
ID: 138,
Subject: 'Review HR Budget Company Wide',
StartDate: '2014/03/20',
DueDate: '2014/03/25',
Status: 'In Progress',
Priority: 'Normal',
Completion: 40,
EmployeeID: 6,
},
{
ID: 145,
Subject: 'Final Budget Review',
StartDate: '2014/03/26',
DueDate: '2014/03/27',
Status: 'In Progress',
Priority: 'High',
Completion: 25,
EmployeeID: 6,
}];
export default {
getEmployees() {
return employees;
},
getTasks() {
return tasks;
},
};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'root:': '../../../../../',
'npm:': 'https://unpkg.com/',
},
map: {
'vue': 'npm:vue@3.3.4/dist/vue.esm-browser.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.1/index.js',
'demo-ts-loader': 'root:utils/demo-ts-loader.js',
'svg-loader': 'root:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@23.1.5/cjs',
'devextreme-vue': 'npm:devextreme-vue@23.1.5',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.6.2/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.1/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.48/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.4/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.11/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
System.config(window.config);